﻿OpenConsole("Write Default Host Config XML Server")
PrintN("Create default_host.xml...")

IncludeFile "../../inc/lweb_header_privat.pbi"
  
  Global host.host
  host\description = "Default Server"
  host\defaultfile = "index.html"
  host\basedir = "/srv/lweb-srv/"
  host\http\max_clients = 10        ; Max sametime HTTP connections. 
  host\http\port = 8080
  host\http\binding = "127.0.0.1"
  
  host\https\max_clients = 100
  host\https\port = 8443
  host\https\binding = "127.0.0.1"
  host\https\enabled = 0
  host\https\CA = "fullchain.pem"
  host\https\Certs = "cert.pem"
  host\https\key = "privkey.pem"
  host\https\key_pass = ""
  host\cache\enable = 0              ; Enable / Disable Cached Server
  host\cache\time = 120              ; TTL of cached files
  host\cache\maxsize = 1             ; Max Cache
  host\cache\current = 0             ;
  
  host\log\AccesslogFile = "/var/log/lhttpd/default_access.log"
  host\log\CachelogFile  = "/var/log/lhttpd/default_cache.log"
  host\log\ErrorlogFile = "/var/log/lhttpd/default_error.log"
  host\log\DebuglogFile = "/var/log/lhttpd/default_debug.log"
  host\mem\MaxFileSize = 524288      ; Default 512 KiB
  host\mem\DefaultBlockSize = 65536  ; Default Blocksize 64 KiB
  
  If CreateXML(0)
    InsertXMLStructure(RootXMLNode(0), @host, host)
    ExtractXMLStructure(0, @host, host, #PB_XML_NoCase)
    FormatXML(0, #PB_XML_ReFormat)
    ToSave.s = ComposeXML(0)
  EndIf
  
  CreateFile(0, "../cfg/hosts/default_host.xml")
  WriteString(0, ToSave)
  PrintN("Default config xml created: default_host.xml")
  End