﻿;****************************
;*
;* Lihaso Web Server 
;*
;* HTTP/HTTPS example extended Server
;*
;* (c)2015 - 2023 by Linder Hard- und Software
;*
;*

EnableExplicit
OpenConsole("server_example Console")
PrintN("Server_Sample and tests")
;*
;* Includes:
;*

XIncludeFile "lhs_lib/SYS/lhs_log_ext.pbi"    ;User for Access Log, Error Access Log, Error Log and maybe more.
XIncludeFile "lhs_lib/SYS/lhs_sys_debug_wrapper.pbi"
XIncludeFile "lweb_header.pbi"
XIncludeFile "lweb.pbi"

;*
;* Variable declaration:
;*

Define counter, v_lweb_srv_stop
Global Accesslog.s, Errorlog.s, Cachelog.s, DebugLog.s, Debuggings.s

;*
;* Enable extended Logging:
;* 
DebugLog = lhs_log_ext::Create("DebugLog")
lhs_log_ext::SetLogFile(DebugLog, "lweb_debug.log")
lhs_log_ext::Init(DebugLog)
ldl::Register(lhs_log_ext::@Out(), DebugLog, 1, DebugLog, ldl::#AdvancedLog)
ldl::SetDefault(DebugLog)
ldl::Logging("Start Debug Log registered with ldl at UUID:"+DebugLog)

Debuggings = lhs_web::get_config(lhs_web::#conf_Debug_logUUID)
Debug Debuggings
;*
;* includes
;*

XIncludeFile "server_example_function.pbi"

PrintN("Read Configuration:")
;*
;* Read Configuration http & https Server
;*
If lhs_web::server_initial("file:cfg/server_config.xml")
  ldl::Logging("config succesfully loaded.")
Else
  ldl::Logging("config load failed.")
  End
EndIf

PrintN("HTTP an Port:"+lhs_web::server_get_config("ports_http"))
PrintN("HTTPS an Port:"+lhs_web::server_get_config("ports_https"))
PrintN("Configuration read done.")
;*
;* Start Server
;*

PrintN("Start the Server")
If lhs_web::server_start()
  ldl::Logging("Server started")
Else
  ldl::Logging("Start failed.")
  End
EndIf
  
counter = 0
PrintN("Server_Sample started.")
PrintN("Press Enter to Exit")
Input()
lhs_log_ext::StopAllLogger()
lhs_web::server_stop()
PrintN("Finished")

End
